/* idocument.vala
 *
 * Copyright (C) 2008-2009  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

public enum Valide.DocumentState
{
  NORMAL,
  EXTERNALLY_MODIFIED,
  INFO
}

public interface Valide.iDocument : Gtk.Widget
{
  public signal void state_change (DocumentState state);
  public signal void closed ();
  public signal void title_change ();
  public signal void saved ();

  public abstract DocumentState state
  {
    get;
    set;
  }

  public abstract bool is_save
  {
    get;
    set;
  }

  public abstract string path
  {
    owned get;
    set;
  }

  public abstract string title
  {
    owned get;
  }

  public abstract string filename
  {
    owned get;
  }

  public abstract void open (string uri) throws Error;
  public abstract void save ();
  public abstract void save_as ();
  public abstract bool close ();
  public abstract void redo ();
  public abstract void search ();
  public abstract void find_next ();
  public abstract void find_prev ();
  public abstract bool goto_line (int line = -1);
  public abstract Gdk.Pixbuf get_icon ();
}

