/* source-view.vala
 *
 * Copyright (C) 2008-2009  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

public class Valide.SourceView : Gtk.SourceView
{
  public string language
  {
    get;
    construct;
  }

  public SourceView (string language)
  {
    this.language = language;
  }

  construct
  {
    Gtk.SourceLanguageManager lm = new Gtk.SourceLanguageManager ();
    if (this.language != "txt")
    {
      Gtk.SourceBuffer buffer = new Gtk.SourceBuffer.with_language (lm.get_language (this.language));
      buffer.set_highlight_syntax (true);
      this.buffer = buffer;
    }
    else
    {
      this.buffer = new Gtk.SourceBuffer (null);
    }

    Pango.FontDescription desc =  new Pango.FontDescription ();
    desc.set_family ("Monospace");
    this.modify_font (desc);

    this.set_right_margin_position (ConfigManager.get_instance ().get_integer ("GtkSourceView", "right-margin-position"));
    this.set_show_right_margin (ConfigManager.get_instance ().get_boolean ("GtkSourceView", "show-right-margin"));
    this.set_show_line_numbers (ConfigManager.get_instance ().get_boolean ("GtkSourceView", "show-line-numbers"));
    this.set_auto_indent (ConfigManager.get_instance ().get_boolean ("GtkSourceView", "auto-indent"));
    this.set_highlight_current_line (ConfigManager.get_instance ().get_boolean ("GtkSourceView", "highlight-current-line"));
    this.set_indent_width (ConfigManager.get_instance ().get_integer ("GtkSourceView", "indent-width"));
    this.set_indent_on_tab (ConfigManager.get_instance ().get_boolean ("GtkSourceView", "indent-on-tab"));
    this.set_insert_spaces_instead_of_tabs (ConfigManager.get_instance ().get_boolean ("GtkSourceView", "insert-spaces-instead-of-tabs"));
    this.set_smart_home_end (Gtk.SourceSmartHomeEndType.BEFORE);
    this.set_tab_width (ConfigManager.get_instance ().get_integer ("GtkSourceView", "tab-width"));
  }

  public void scroll_to_cursor ()
  {
    Gtk.TextBuffer buffer = this.buffer;
  	this.scroll_to_mark (buffer.get_insert (), 0.25, false, 0.0, 0.0);
  }
}

