/* document-message.vala
 *
 * Copyright (C) 2008-2009  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

#ifndef __LIBVALIDE_DOCUMENT_MESSAGE_H__
#define __LIBVALIDE_DOCUMENT_MESSAGE_H__

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <libvalide/abstract-text-document.h>

G_BEGIN_DECLS


#define VALIDE_TYPE_DOCUMENT_MESSAGE (valide_document_message_get_type ())
#define VALIDE_DOCUMENT_MESSAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_DOCUMENT_MESSAGE, ValideDocumentMessage))
#define VALIDE_DOCUMENT_MESSAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_DOCUMENT_MESSAGE, ValideDocumentMessageClass))
#define VALIDE_IS_DOCUMENT_MESSAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_DOCUMENT_MESSAGE))
#define VALIDE_IS_DOCUMENT_MESSAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_DOCUMENT_MESSAGE))
#define VALIDE_DOCUMENT_MESSAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_DOCUMENT_MESSAGE, ValideDocumentMessageClass))

typedef struct _ValideDocumentMessage ValideDocumentMessage;
typedef struct _ValideDocumentMessageClass ValideDocumentMessageClass;
typedef struct _ValideDocumentMessagePrivate ValideDocumentMessagePrivate;

struct _ValideDocumentMessage {
	GtkHBox parent_instance;
	ValideDocumentMessagePrivate * priv;
};

struct _ValideDocumentMessageClass {
	GtkHBoxClass parent_class;
};


ValideDocumentMessage* valide_document_message_construct (GType object_type, ValideAbstractTextDocument* document);
ValideDocumentMessage* valide_document_message_new (ValideAbstractTextDocument* document);
ValideAbstractTextDocument* valide_document_message_get_document (ValideDocumentMessage* self);
GType valide_document_message_get_type (void);


G_END_DECLS

#endif
