/* document.vala
 *
 * Copyright (C) 2008-2009  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

#ifndef __LIBVALIDE_DOCUMENT_H__
#define __LIBVALIDE_DOCUMENT_H__

#include <glib.h>
#include <glib-object.h>
#include <libvalide/abstract-text-document.h>
#include <libvalide/split-source-view.h>

G_BEGIN_DECLS


#define VALIDE_TYPE_TXT_DOCUMENT (valide_txt_document_get_type ())
#define VALIDE_TXT_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_TXT_DOCUMENT, ValideTxtDocument))
#define VALIDE_TXT_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_TXT_DOCUMENT, ValideTxtDocumentClass))
#define VALIDE_IS_TXT_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_TXT_DOCUMENT))
#define VALIDE_IS_TXT_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_TXT_DOCUMENT))
#define VALIDE_TXT_DOCUMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_TXT_DOCUMENT, ValideTxtDocumentClass))

typedef struct _ValideTxtDocument ValideTxtDocument;
typedef struct _ValideTxtDocumentClass ValideTxtDocumentClass;
typedef struct _ValideTxtDocumentPrivate ValideTxtDocumentPrivate;

#define VALIDE_TYPE_VALA_DOCUMENT (valide_vala_document_get_type ())
#define VALIDE_VALA_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_VALA_DOCUMENT, ValideValaDocument))
#define VALIDE_VALA_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_VALA_DOCUMENT, ValideValaDocumentClass))
#define VALIDE_IS_VALA_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_VALA_DOCUMENT))
#define VALIDE_IS_VALA_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_VALA_DOCUMENT))
#define VALIDE_VALA_DOCUMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_VALA_DOCUMENT, ValideValaDocumentClass))

typedef struct _ValideValaDocument ValideValaDocument;
typedef struct _ValideValaDocumentClass ValideValaDocumentClass;
typedef struct _ValideValaDocumentPrivate ValideValaDocumentPrivate;

#define VALIDE_TYPE_VAPI_DOCUMENT (valide_vapi_document_get_type ())
#define VALIDE_VAPI_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_VAPI_DOCUMENT, ValideVapiDocument))
#define VALIDE_VAPI_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_VAPI_DOCUMENT, ValideVapiDocumentClass))
#define VALIDE_IS_VAPI_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_VAPI_DOCUMENT))
#define VALIDE_IS_VAPI_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_VAPI_DOCUMENT))
#define VALIDE_VAPI_DOCUMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_VAPI_DOCUMENT, ValideVapiDocumentClass))

typedef struct _ValideVapiDocument ValideVapiDocument;
typedef struct _ValideVapiDocumentClass ValideVapiDocumentClass;
typedef struct _ValideVapiDocumentPrivate ValideVapiDocumentPrivate;

#define VALIDE_TYPE_XML_DOCUMENT (valide_xml_document_get_type ())
#define VALIDE_XML_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_XML_DOCUMENT, ValideXmlDocument))
#define VALIDE_XML_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_XML_DOCUMENT, ValideXmlDocumentClass))
#define VALIDE_IS_XML_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_XML_DOCUMENT))
#define VALIDE_IS_XML_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_XML_DOCUMENT))
#define VALIDE_XML_DOCUMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_XML_DOCUMENT, ValideXmlDocumentClass))

typedef struct _ValideXmlDocument ValideXmlDocument;
typedef struct _ValideXmlDocumentClass ValideXmlDocumentClass;
typedef struct _ValideXmlDocumentPrivate ValideXmlDocumentPrivate;

#define VALIDE_TYPE_GLADE_DOCUMENT (valide_glade_document_get_type ())
#define VALIDE_GLADE_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_GLADE_DOCUMENT, ValideGladeDocument))
#define VALIDE_GLADE_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_GLADE_DOCUMENT, ValideGladeDocumentClass))
#define VALIDE_IS_GLADE_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_GLADE_DOCUMENT))
#define VALIDE_IS_GLADE_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_GLADE_DOCUMENT))
#define VALIDE_GLADE_DOCUMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_GLADE_DOCUMENT, ValideGladeDocumentClass))

typedef struct _ValideGladeDocument ValideGladeDocument;
typedef struct _ValideGladeDocumentClass ValideGladeDocumentClass;
typedef struct _ValideGladeDocumentPrivate ValideGladeDocumentPrivate;

#define VALIDE_TYPE_UI_DOCUMENT (valide_ui_document_get_type ())
#define VALIDE_UI_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_UI_DOCUMENT, ValideUiDocument))
#define VALIDE_UI_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_UI_DOCUMENT, ValideUiDocumentClass))
#define VALIDE_IS_UI_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_UI_DOCUMENT))
#define VALIDE_IS_UI_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_UI_DOCUMENT))
#define VALIDE_UI_DOCUMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_UI_DOCUMENT, ValideUiDocumentClass))

typedef struct _ValideUiDocument ValideUiDocument;
typedef struct _ValideUiDocumentClass ValideUiDocumentClass;
typedef struct _ValideUiDocumentPrivate ValideUiDocumentPrivate;

struct _ValideTxtDocument {
	ValideAbstractTextDocument parent_instance;
	ValideTxtDocumentPrivate * priv;
};

struct _ValideTxtDocumentClass {
	ValideAbstractTextDocumentClass parent_class;
};

struct _ValideValaDocument {
	ValideTxtDocument parent_instance;
	ValideValaDocumentPrivate * priv;
};

struct _ValideValaDocumentClass {
	ValideTxtDocumentClass parent_class;
};

struct _ValideVapiDocument {
	ValideValaDocument parent_instance;
	ValideVapiDocumentPrivate * priv;
};

struct _ValideVapiDocumentClass {
	ValideValaDocumentClass parent_class;
};

struct _ValideXmlDocument {
	ValideTxtDocument parent_instance;
	ValideXmlDocumentPrivate * priv;
};

struct _ValideXmlDocumentClass {
	ValideTxtDocumentClass parent_class;
};

struct _ValideGladeDocument {
	ValideXmlDocument parent_instance;
	ValideGladeDocumentPrivate * priv;
};

struct _ValideGladeDocumentClass {
	ValideXmlDocumentClass parent_class;
};

struct _ValideUiDocument {
	ValideXmlDocument parent_instance;
	ValideUiDocumentPrivate * priv;
};

struct _ValideUiDocumentClass {
	ValideXmlDocumentClass parent_class;
};


ValideTxtDocument* valide_txt_document_construct (GType object_type);
ValideTxtDocument* valide_txt_document_new (void);
GType valide_txt_document_get_type (void);
ValideValaDocument* valide_vala_document_construct (GType object_type);
ValideValaDocument* valide_vala_document_new (void);
GType valide_vala_document_get_type (void);
ValideVapiDocument* valide_vapi_document_construct (GType object_type);
ValideVapiDocument* valide_vapi_document_new (void);
GType valide_vapi_document_get_type (void);
ValideXmlDocument* valide_xml_document_construct (GType object_type);
ValideXmlDocument* valide_xml_document_new (void);
GType valide_xml_document_get_type (void);
ValideGladeDocument* valide_glade_document_construct (GType object_type);
ValideGladeDocument* valide_glade_document_new (void);
GType valide_glade_document_get_type (void);
ValideUiDocument* valide_ui_document_construct (GType object_type);
ValideUiDocument* valide_ui_document_new (void);
GType valide_ui_document_get_type (void);


G_END_DECLS

#endif
