/* plugin-preferences.vala
 *
 * Copyright (C) 2008-2009  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

#ifndef __LIBVALIDE_PLUGIN_PREFERENCES_H__
#define __LIBVALIDE_PLUGIN_PREFERENCES_H__

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <libvalide/plugin-manager.h>

G_BEGIN_DECLS


#define VALIDE_TYPE_PLUGIN_PREFERENCES (valide_plugin_preferences_get_type ())
#define VALIDE_PLUGIN_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_PLUGIN_PREFERENCES, ValidePluginPreferences))
#define VALIDE_PLUGIN_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_PLUGIN_PREFERENCES, ValidePluginPreferencesClass))
#define VALIDE_IS_PLUGIN_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_PLUGIN_PREFERENCES))
#define VALIDE_IS_PLUGIN_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_PLUGIN_PREFERENCES))
#define VALIDE_PLUGIN_PREFERENCES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_PLUGIN_PREFERENCES, ValidePluginPreferencesClass))

typedef struct _ValidePluginPreferences ValidePluginPreferences;
typedef struct _ValidePluginPreferencesClass ValidePluginPreferencesClass;
typedef struct _ValidePluginPreferencesPrivate ValidePluginPreferencesPrivate;

struct _ValidePluginPreferences {
	GtkVBox parent_instance;
	ValidePluginPreferencesPrivate * priv;
};

struct _ValidePluginPreferencesClass {
	GtkVBoxClass parent_class;
};


ValidePluginPreferences* valide_plugin_preferences_construct (GType object_type, ValidePluginManager* plugin_manager);
ValidePluginPreferences* valide_plugin_preferences_new (ValidePluginManager* plugin_manager);
ValidePluginManager* valide_plugin_preferences_get_plugin_manager (ValidePluginPreferences* self);
GType valide_plugin_preferences_get_type (void);


G_END_DECLS

#endif
