/* plugin.vala
 *
 * Copyright (C) 2008-2009  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

#ifndef __LIBVALIDE_PLUGIN_H__
#define __LIBVALIDE_PLUGIN_H__

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

G_BEGIN_DECLS


#define VALIDE_TYPE_PLUGIN (valide_plugin_get_type ())
#define VALIDE_PLUGIN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_PLUGIN, ValidePlugin))
#define VALIDE_PLUGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_PLUGIN, ValidePluginClass))
#define VALIDE_IS_PLUGIN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_PLUGIN))
#define VALIDE_IS_PLUGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_PLUGIN))
#define VALIDE_PLUGIN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_PLUGIN, ValidePluginClass))

typedef struct _ValidePlugin ValidePlugin;
typedef struct _ValidePluginClass ValidePluginClass;
typedef struct _ValidePluginPrivate ValidePluginPrivate;

struct _ValidePlugin {
	GObject parent_instance;
	ValidePluginPrivate * priv;
};

struct _ValidePluginClass {
	GObjectClass parent_class;
};


char* valide_plugin_get_path (ValidePlugin* self);
GType valide_plugin_get_type (void);


G_END_DECLS

#endif
