/* preferences-dialog.vala
 *
 * Copyright (C) 2008-2009  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

#ifndef __LIBVALIDE_PREFERENCES_DIALOG_H__
#define __LIBVALIDE_PREFERENCES_DIALOG_H__

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <libvalide/ui/abstract-preferences-dialog.h>

G_BEGIN_DECLS


#define VALIDE_TYPE_PREFERENCES_DIALOG (valide_preferences_dialog_get_type ())
#define VALIDE_PREFERENCES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_PREFERENCES_DIALOG, ValidePreferencesDialog))
#define VALIDE_PREFERENCES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_PREFERENCES_DIALOG, ValidePreferencesDialogClass))
#define VALIDE_IS_PREFERENCES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_PREFERENCES_DIALOG))
#define VALIDE_IS_PREFERENCES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_PREFERENCES_DIALOG))
#define VALIDE_PREFERENCES_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_PREFERENCES_DIALOG, ValidePreferencesDialogClass))

typedef struct _ValidePreferencesDialog ValidePreferencesDialog;
typedef struct _ValidePreferencesDialogClass ValidePreferencesDialogClass;
typedef struct _ValidePreferencesDialogPrivate ValidePreferencesDialogPrivate;

/* @todo set_smart_home_end */
struct _ValidePreferencesDialog {
	ValideAbstractPreferencesDialog parent_instance;
	ValidePreferencesDialogPrivate * priv;
};

struct _ValidePreferencesDialogClass {
	ValideAbstractPreferencesDialogClass parent_class;
};


void valide_preferences_dialog_update_param (GtkWidget* sender, ValidePreferencesDialog* self);
void valide_preferences_dialog_set_param (ValidePreferencesDialog* self, GError** error);
gint valide_preferences_dialog_run (ValidePreferencesDialog* self);
void valide_preferences_dialog_destroy (ValidePreferencesDialog* self);
ValidePreferencesDialog* valide_preferences_dialog_construct (GType object_type);
ValidePreferencesDialog* valide_preferences_dialog_new (void);
GType valide_preferences_dialog_get_type (void);


G_END_DECLS

#endif
