/* project-dialog-remove.vala
 *
 * Copyright (C) 2008-2009  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

#ifndef __LIBVALIDE_PROJECT_DIALOG_REMOVE_H__
#define __LIBVALIDE_PROJECT_DIALOG_REMOVE_H__

#include <glib.h>
#include <glib-object.h>
#include <libvalide/ui/abstract-project-dialog-remove.h>
#include <libvalide/project.h>

G_BEGIN_DECLS


#define VALIDE_TYPE_PROJECT_DIALOG_REMOVE (valide_project_dialog_remove_get_type ())
#define VALIDE_PROJECT_DIALOG_REMOVE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_PROJECT_DIALOG_REMOVE, ValideProjectDialogRemove))
#define VALIDE_PROJECT_DIALOG_REMOVE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_PROJECT_DIALOG_REMOVE, ValideProjectDialogRemoveClass))
#define VALIDE_IS_PROJECT_DIALOG_REMOVE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_PROJECT_DIALOG_REMOVE))
#define VALIDE_IS_PROJECT_DIALOG_REMOVE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_PROJECT_DIALOG_REMOVE))
#define VALIDE_PROJECT_DIALOG_REMOVE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_PROJECT_DIALOG_REMOVE, ValideProjectDialogRemoveClass))

typedef struct _ValideProjectDialogRemove ValideProjectDialogRemove;
typedef struct _ValideProjectDialogRemoveClass ValideProjectDialogRemoveClass;
typedef struct _ValideProjectDialogRemovePrivate ValideProjectDialogRemovePrivate;

struct _ValideProjectDialogRemove {
	ValideAbstractProjectDialogRemove parent_instance;
	ValideProjectDialogRemovePrivate * priv;
};

struct _ValideProjectDialogRemoveClass {
	ValideAbstractProjectDialogRemoveClass parent_class;
};


ValideProjectDialogRemove* valide_project_dialog_remove_construct (GType object_type, ValideProject* project);
ValideProjectDialogRemove* valide_project_dialog_remove_new (ValideProject* project);
gint valide_project_dialog_remove_run (ValideProjectDialogRemove* self);
void valide_project_dialog_remove_destroy (ValideProjectDialogRemove* self);
ValideProject* valide_project_dialog_remove_get_project (ValideProjectDialogRemove* self);
GList* valide_project_dialog_remove_get_selected_files (ValideProjectDialogRemove* self);
GType valide_project_dialog_remove_get_type (void);


G_END_DECLS

#endif
