/* aboutdialog.vala
 *
 * Copyright (C) 2008-2009  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

#ifndef __LIBVALIDE_STATUSBAR_H__
#define __LIBVALIDE_STATUSBAR_H__

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>

G_BEGIN_DECLS


#define VALIDE_TYPE_STATUSBAR (valide_statusbar_get_type ())
#define VALIDE_STATUSBAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_STATUSBAR, ValideStatusbar))
#define VALIDE_STATUSBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_STATUSBAR, ValideStatusbarClass))
#define VALIDE_IS_STATUSBAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_STATUSBAR))
#define VALIDE_IS_STATUSBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_STATUSBAR))
#define VALIDE_STATUSBAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_STATUSBAR, ValideStatusbarClass))

typedef struct _ValideStatusbar ValideStatusbar;
typedef struct _ValideStatusbarClass ValideStatusbarClass;
typedef struct _ValideStatusbarPrivate ValideStatusbarPrivate;

/*
 * This code is re-writing in the vala language of GeditStatusbar
 *
 * Copyright (C) 2006-2008  Jürg Billeter, Raffaele Sandrini
 * Copyright (C) 2007  Mathias Hasselmann
 */
struct _ValideStatusbar {
	GtkStatusbar parent_instance;
	ValideStatusbarPrivate * priv;
};

struct _ValideStatusbarClass {
	GtkStatusbarClass parent_class;
};


ValideStatusbar* valide_statusbar_get_instance (void);
void valide_statusbar_set_has_resize_grip (ValideStatusbar* self, gboolean show);
void valide_statusbar_set_cursor_position (ValideStatusbar* self, gint line, gint col);
void valide_statusbar_flash_message (ValideStatusbar* self, guint context_id, const char* msg);
GType valide_statusbar_get_type (void);


G_END_DECLS

#endif
