/* template-manager.vala
 *
 * Copyright (C) 2008-2009  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

#ifndef __LIBVALIDE_TEMPLATE_MANAGER_H__
#define __LIBVALIDE_TEMPLATE_MANAGER_H__

#include <glib.h>
#include <glib-object.h>

G_BEGIN_DECLS


#define VALIDE_TYPE_TEMPLATE_MANAGER (valide_template_manager_get_type ())
#define VALIDE_TEMPLATE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_TEMPLATE_MANAGER, ValideTemplateManager))
#define VALIDE_TEMPLATE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_TEMPLATE_MANAGER, ValideTemplateManagerClass))
#define VALIDE_IS_TEMPLATE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_TEMPLATE_MANAGER))
#define VALIDE_IS_TEMPLATE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_TEMPLATE_MANAGER))
#define VALIDE_TEMPLATE_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_TEMPLATE_MANAGER, ValideTemplateManagerClass))

typedef struct _ValideTemplateManager ValideTemplateManager;
typedef struct _ValideTemplateManagerClass ValideTemplateManagerClass;
typedef struct _ValideTemplateManagerPrivate ValideTemplateManagerPrivate;

struct _ValideTemplateManager {
	GObject parent_instance;
	ValideTemplateManagerPrivate * priv;
};

struct _ValideTemplateManagerClass {
	GObjectClass parent_class;
};


ValideTemplateManager* valide_template_manager_get_instance (void);
GList* valide_template_manager_get_list (ValideTemplateManager* self);
GType valide_template_manager_get_type (void);


G_END_DECLS

#endif
