/* completion.vala
 *
 * Copyright (C) 2008  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

#ifndef __PLUGINS_COMPLETION_COMPLETION_H__
#define __PLUGINS_COMPLETION_COMPLETION_H__

#include <glib.h>
#include <glib-object.h>
#include <libvalide/plugin.h>

G_BEGIN_DECLS


#define TYPE_COMPLETION_PLUGIN (completion_plugin_get_type ())
#define COMPLETION_PLUGIN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMPLETION_PLUGIN, CompletionPlugin))
#define COMPLETION_PLUGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMPLETION_PLUGIN, CompletionPluginClass))
#define IS_COMPLETION_PLUGIN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMPLETION_PLUGIN))
#define IS_COMPLETION_PLUGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMPLETION_PLUGIN))
#define COMPLETION_PLUGIN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMPLETION_PLUGIN, CompletionPluginClass))

typedef struct _CompletionPlugin CompletionPlugin;
typedef struct _CompletionPluginClass CompletionPluginClass;
typedef struct _CompletionPluginPrivate CompletionPluginPrivate;

struct _CompletionPlugin {
	ValidePlugin parent_instance;
	CompletionPluginPrivate * priv;
};

struct _CompletionPluginClass {
	ValidePluginClass parent_class;
};


CompletionPlugin* completion_plugin_construct (GType object_type);
CompletionPlugin* completion_plugin_new (void);
GType completion_plugin_get_type (void);
GType register_plugin (void);


G_END_DECLS

#endif
