/* source-buffer.vala
 *
 * Copyright (C) 2008  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 *  Nicolas Joseph <gege2061@redaction-developpez.com>
 */

#ifndef __PLUGINS_COMPLETION_SOURCE_BUFFER_H__
#define __PLUGINS_COMPLETION_SOURCE_BUFFER_H__

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

G_BEGIN_DECLS


#define COMPLETION_TYPE_SOURCE_BUFFER (completion_source_buffer_get_type ())
#define COMPLETION_SOURCE_BUFFER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), COMPLETION_TYPE_SOURCE_BUFFER, CompletionSourceBuffer))
#define COMPLETION_SOURCE_BUFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), COMPLETION_TYPE_SOURCE_BUFFER, CompletionSourceBufferClass))
#define COMPLETION_IS_SOURCE_BUFFER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), COMPLETION_TYPE_SOURCE_BUFFER))
#define COMPLETION_IS_SOURCE_BUFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), COMPLETION_TYPE_SOURCE_BUFFER))
#define COMPLETION_SOURCE_BUFFER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), COMPLETION_TYPE_SOURCE_BUFFER, CompletionSourceBufferClass))

typedef struct _CompletionSourceBuffer CompletionSourceBuffer;
typedef struct _CompletionSourceBufferClass CompletionSourceBufferClass;
typedef struct _CompletionSourceBufferPrivate CompletionSourceBufferPrivate;

struct _CompletionSourceBuffer {
	GObject parent_instance;
	CompletionSourceBufferPrivate * priv;
};

struct _CompletionSourceBufferClass {
	GObjectClass parent_class;
};


CompletionSourceBuffer* completion_source_buffer_construct (GType object_type, const char* name, const char* source);
CompletionSourceBuffer* completion_source_buffer_new (const char* name, const char* source);
const char* completion_source_buffer_get_name (CompletionSourceBuffer* self);
const char* completion_source_buffer_get_source (CompletionSourceBuffer* self);
void* completion_source_buffer_get_data (CompletionSourceBuffer* self);
void completion_source_buffer_set_data (CompletionSourceBuffer* self, void* value);
GType completion_source_buffer_get_type (void);


G_END_DECLS

#endif
