/* info.vala
 *
 * Copyright (C) 2008  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 *  Nicolas Joseph <gege2061@redaction-developpez.com>
 */

#ifndef __PLUGINS_COMPLETION_SOURCE_COMPLETION_INFO_H__
#define __PLUGINS_COMPLETION_SOURCE_COMPLETION_INFO_H__

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>

G_BEGIN_DECLS


#define SOURCE_COMPLETION_TYPE_INFO (source_completion_info_get_type ())
#define SOURCE_COMPLETION_INFO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOURCE_COMPLETION_TYPE_INFO, SourceCompletionInfo))
#define SOURCE_COMPLETION_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SOURCE_COMPLETION_TYPE_INFO, SourceCompletionInfoClass))
#define SOURCE_COMPLETION_IS_INFO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOURCE_COMPLETION_TYPE_INFO))
#define SOURCE_COMPLETION_IS_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SOURCE_COMPLETION_TYPE_INFO))
#define SOURCE_COMPLETION_INFO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SOURCE_COMPLETION_TYPE_INFO, SourceCompletionInfoClass))

typedef struct _SourceCompletionInfo SourceCompletionInfo;
typedef struct _SourceCompletionInfoClass SourceCompletionInfoClass;
typedef struct _SourceCompletionInfoPrivate SourceCompletionInfoPrivate;

#define SOURCE_COMPLETION_INFO_TYPE_INFO_TYPE (source_completion_info_info_type_get_type ())

/*
 * This code is re-writing in the vala language of GtkSourceCompletion
 *
 * Copyright (C) 2007 - Chuchiperriman
 *
 * rev 163
 */
struct _SourceCompletionInfo {
	GtkWindow parent_instance;
	SourceCompletionInfoPrivate * priv;
};

struct _SourceCompletionInfoClass {
	GtkWindowClass parent_class;
};

typedef enum  {
	SOURCE_COMPLETION_INFO_INFO_TYPE_VIEW_SORT,
	SOURCE_COMPLETION_INFO_INFO_TYPE_VIEW_EXTENDED
} SourceCompletionInfoInfoType;


GType source_completion_info_info_type_get_type (void);
void source_completion_info_show (SourceCompletionInfo* self);
void source_completion_info_hide (SourceCompletionInfo* self);
SourceCompletionInfo* source_completion_info_construct (GType object_type);
SourceCompletionInfo* source_completion_info_new (void);
void source_completion_info_move_to_cursor (SourceCompletionInfo* self, GtkTextView* view);
void source_completion_info_set_markup (SourceCompletionInfo* self, const char* markup);
void source_completion_info_set_adjust_height (SourceCompletionInfo* self, gboolean adjust, gint max_height);
void source_completion_info_set_adjust_width (SourceCompletionInfo* self, gboolean adjust, gint max_width);
void source_completion_info_set_info_type (SourceCompletionInfo* self, SourceCompletionInfoInfoType type);
GType source_completion_info_get_type (void);


G_END_DECLS

#endif
