/* provider-file.vala
 *
 * Copyright (C) 2008  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 *  Nicolas Joseph <gege2061@redaction-developpez.com>
 */

#ifndef __PLUGINS_COMPLETION_SOURCE_COMPLETION_PROVIDER_FILE_H__
#define __PLUGINS_COMPLETION_SOURCE_COMPLETION_PROVIDER_FILE_H__

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <plugins/completion/source-completion/provider.h>
#include <plugins/completion/source-completion/trigger.h>

G_BEGIN_DECLS


#define SOURCE_COMPLETION_TYPE_PROVIDER_FILE (source_completion_provider_file_get_type ())
#define SOURCE_COMPLETION_PROVIDER_FILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOURCE_COMPLETION_TYPE_PROVIDER_FILE, SourceCompletionProviderFile))
#define SOURCE_COMPLETION_PROVIDER_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SOURCE_COMPLETION_TYPE_PROVIDER_FILE, SourceCompletionProviderFileClass))
#define SOURCE_COMPLETION_IS_PROVIDER_FILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOURCE_COMPLETION_TYPE_PROVIDER_FILE))
#define SOURCE_COMPLETION_IS_PROVIDER_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SOURCE_COMPLETION_TYPE_PROVIDER_FILE))
#define SOURCE_COMPLETION_PROVIDER_FILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SOURCE_COMPLETION_TYPE_PROVIDER_FILE, SourceCompletionProviderFileClass))

typedef struct _SourceCompletionProviderFile SourceCompletionProviderFile;
typedef struct _SourceCompletionProviderFileClass SourceCompletionProviderFileClass;
typedef struct _SourceCompletionProviderFilePrivate SourceCompletionProviderFilePrivate;

/*
 * This code is re-writing in the vala language of GtkSourceCompletion
 *
 * Copyright (C) 2008 - perriman
 *
 * rev 163
 */
struct _SourceCompletionProviderFile {
	GObject parent_instance;
	SourceCompletionProviderFilePrivate * priv;
};

struct _SourceCompletionProviderFileClass {
	GObjectClass parent_class;
	char* (*get_name) (SourceCompletionProviderFile* self);
	GList* (*get_proposals) (SourceCompletionProviderFile* self, SourceCompletionTrigger* trigger);
	void (*finish) (SourceCompletionProviderFile* self);
};


char* source_completion_provider_file_get_name (SourceCompletionProviderFile* self);
GList* source_completion_provider_file_get_proposals (SourceCompletionProviderFile* self, SourceCompletionTrigger* trigger);
void source_completion_provider_file_finish (SourceCompletionProviderFile* self);
SourceCompletionProviderFile* source_completion_provider_file_construct (GType object_type, GtkTextView* view);
SourceCompletionProviderFile* source_completion_provider_file_new (GtkTextView* view);
void source_completion_provider_file_set_file (SourceCompletionProviderFile* self, const char* file);
GtkTextView* source_completion_provider_file_get_view (SourceCompletionProviderFile* self);
GType source_completion_provider_file_get_type (void);


G_END_DECLS

#endif
