/* provider.vala
 *
 * Copyright (C) 2008  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

#ifndef __PLUGINS_COMPLETION_SOURCE_COMPLETION_PROVIDER_H__
#define __PLUGINS_COMPLETION_SOURCE_COMPLETION_PROVIDER_H__

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <plugins/completion/source-completion/trigger.h>

G_BEGIN_DECLS


#define SOURCE_COMPLETION_TYPE_PROVIDER (source_completion_provider_get_type ())
#define SOURCE_COMPLETION_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOURCE_COMPLETION_TYPE_PROVIDER, SourceCompletionProvider))
#define SOURCE_COMPLETION_IS_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOURCE_COMPLETION_TYPE_PROVIDER))
#define SOURCE_COMPLETION_PROVIDER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), SOURCE_COMPLETION_TYPE_PROVIDER, SourceCompletionProviderIface))

typedef struct _SourceCompletionProvider SourceCompletionProvider;
typedef struct _SourceCompletionProviderIface SourceCompletionProviderIface;

/*
 * This code is re-writing in the vala language of GtkSourceCompletion
 *
 * Copyright (C) 2007 - Chuchiperriman
 */
struct _SourceCompletionProviderIface {
	GTypeInterface parent_iface;
	char* (*get_name) (SourceCompletionProvider* self);
	GList* (*get_proposals) (SourceCompletionProvider* self, SourceCompletionTrigger* trigger);
	void (*finish) (SourceCompletionProvider* self);
};


char* source_completion_provider_get_name (SourceCompletionProvider* self);
GList* source_completion_provider_get_proposals (SourceCompletionProvider* self, SourceCompletionTrigger* trigger);
void source_completion_provider_finish (SourceCompletionProvider* self);
GType source_completion_provider_get_type (void);


G_END_DECLS

#endif
