/* trigger.vala
 *
 * Copyright (C) 2008  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

#ifndef __PLUGINS_COMPLETION_SOURCE_COMPLETION_TRIGGER_H__
#define __PLUGINS_COMPLETION_SOURCE_COMPLETION_TRIGGER_H__

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

G_BEGIN_DECLS


#define SOURCE_COMPLETION_TYPE_TRIGGER (source_completion_trigger_get_type ())
#define SOURCE_COMPLETION_TRIGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOURCE_COMPLETION_TYPE_TRIGGER, SourceCompletionTrigger))
#define SOURCE_COMPLETION_IS_TRIGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOURCE_COMPLETION_TYPE_TRIGGER))
#define SOURCE_COMPLETION_TRIGGER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), SOURCE_COMPLETION_TYPE_TRIGGER, SourceCompletionTriggerIface))

typedef struct _SourceCompletionTrigger SourceCompletionTrigger;
typedef struct _SourceCompletionTriggerIface SourceCompletionTriggerIface;

/*
 * This code is re-writing in the vala language of GtkSourceCompletion
 *
 * Copyright (C) 2007 - Chuchiperriman
 *
 * rev 163
 */
struct _SourceCompletionTriggerIface {
	GTypeInterface parent_iface;
	char* (*get_name) (SourceCompletionTrigger* self);
	gboolean (*activate) (SourceCompletionTrigger* self);
	gboolean (*deactivate) (SourceCompletionTrigger* self);
};


char* source_completion_trigger_get_name (SourceCompletionTrigger* self);
gboolean source_completion_trigger_activate (SourceCompletionTrigger* self);
gboolean source_completion_trigger_deactivate (SourceCompletionTrigger* self);
GType source_completion_trigger_get_type (void);


G_END_DECLS

#endif
