/* proposal.vala
 *
 * Copyright (C) 2008  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

/*
 * This code is re-writing in the vala language of GtkSourceCompletion
 *
 * Copyright (C) 2008 - ChuchiPerriman
 *
 * rev 163
 */

public class SourceCompletion.Proposal : Object
{
  public const string DEFAULT_PAGE="Default";

  public signal bool apply (Gtk.TextView view);

  public string label
  {
    get;
    set construct;
  }

  public string info
  {
    get;
    set construct;
  }

  public Gdk.Pixbuf icon
  {
    get;
    set construct;
  }

  public string page_name
  {
    get;
    set;
  }

  public Proposal (string label, string? info, Gdk.Pixbuf icon)
  {
    this.label = label;
    this.info = info;
    this.icon = icon;
  }

  construct
  {
    this.page_name = Proposal.DEFAULT_PAGE;
    this.apply += this.apply_default;
  }

  private bool apply_default (Proposal sender, Gtk.TextView view)
  {
    Utils.replace_actual_word (view, sender.label);
    return false;
  }
}

