/* splashscreen.vala
 *
 * Copyright (C) 2008-2009  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

public class Valide.SplashScreen : Gtk.Window
{
  construct
  {
    this.type = Gtk.WindowType.POPUP;
    this.set_position (Gtk.WindowPosition.CENTER);
    Gtk.VBox vbox = new Gtk.VBox (false, 0);
    this.add (vbox);

    Gtk.Image image = new Gtk.Image.from_file (Path.build_filename (Config.PACKAGE_PIXMAPS_DIR, "logo.png"));
    vbox.pack_start (image, true, true, 0);
  }

  public bool run ()
  {
    this.show_all ();
    while (Gtk.events_pending ())
    {
      Gtk.main_iteration ();
    }

    bool opened = false;
    Window window = Window.get_instance ();
    ProjectManager projects = ProjectManager.get_instance ();
    DocumentManager documents = DocumentManager.get_instance ();

    window.run ();
    foreach (string arg in Main.param)
    {
      try
      {
        if (projects.accept_file (arg))
        {
          projects.open (arg);
          opened = true;
        }
        else
        {
          documents.create (arg);
          opened = true;
        }
      }
      catch (Error e)
      {
        debug (e.message);
      }
    }
    if (opened)
    {
      documents.hide_start_page ();
    }
    this.destroy ();
    return false;
  }
}

