using Valide;

public void add_vala_tests ()
{
  Test.add_func ("/valide/vala/compiler_name", () => {
      string result;

      result = new Vala ().compiler_name;
      assert (result == "valac");
    }
  );

  Test.add_func ("/valide/vala/find_program_in_path", () => {
      string result;

      result = new Vala ().prefix;
      assert (FileUtils.test (result, FileTest.IS_DIR));
    }
  );

  Test.add_func ("/valide/vala/vapi_dir", () => {
      string result;

      result = new Vala ().vapi_dir;
      assert (FileUtils.test (result, FileTest.IS_DIR));
      result = Path.build_filename (result, "glib-2.0.vapi");
      assert (FileUtils.test (result, FileTest.IS_REGULAR));
    }
  );

  Test.add_func ("/valide/vala/get_package_list", () => {
      List<string> result;

      result = Vala.get_package_list (null);
      foreach (string vapi in result)
      {
        assert (FileUtils.test (Path.build_filename (new Vala ().vapi_dir, vapi + ".vapi"), FileTest.IS_REGULAR));
      }
    }
  );
}
